<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Role extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->model('Mrole');
        $this->load->library('form_validation');
    }

    public function index()
    {
        $role = $this->Mrole->get_all();

        $data = array(
            'role_data' => $role
        );

        $this->template->load('blank','role/Role_list', $data);
    }

    

    public function create() 
    {
        $data = array(
            'button' => 'Form Tambah',
            'action' => site_url('role/create_action'),
	    'id_inc' => set_value('id_inc'),
	    'nama_role' => set_value('nama_role'),
	);
        $this->template->load('blank','role/Role_form', $data);
    }
    
    public function create_action() 
    {
        $this->_rules();

        if ($this->form_validation->run() == FALSE) {
            $this->create();
        } else {
            $data = array(
		'nama_role' => $this->input->post('nama_role',TRUE),
	    );

           $this->Mrole->insert($data);
            
            redirect(site_url('role'));
        }
    }
    
    public function update($id) 
    {
        $row = $this->Mrole->get_by_id($id);

        if ($row) {
            $data = array(
                'button' => 'Form Edit',
                'action' => site_url('role/update_action'),
		'id_inc' => set_value('id_inc', $row->id_inc),
		'nama_role' => set_value('nama_role', $row->nama_role),
	    );
            $this->template->load('blank','role/Role_form', $data);
        } else {
            $this->session->set_flashdata('message', 'Record Not Found');
            redirect(site_url('role'));
        }
    }
    
    public function update_action() 
    {
        $this->_rules();

        if ($this->form_validation->run() == FALSE) {
            $this->update($this->input->post('id_inc', TRUE));
        } else {
            $data = array(
		'nama_role' => $this->input->post('nama_role',TRUE),
	    );

            $this->Mrole->update($this->input->post('id_inc', TRUE), $data);
            
            redirect(site_url('role'));
        }
    }
    
    public function delete($id) 
    {
        $row = $this->Mrole->get_by_id($id);

        if ($row) {
            $this->Mrole->delete($id);
            
            
            redirect(site_url('role'));
        } else {
            $this->session->set_flashdata('message', 'Record Not Found');
            redirect(site_url('role'));
        }
    }

    public function _rules() 
    {
	$this->form_validation->set_rules('nama_role', 'nama role', 'trim|required');

	$this->form_validation->set_rules('id_inc', 'id_inc', 'trim');
	$this->form_validation->set_error_delimiters('<span class="text-danger">', '</span>');
    }

    function settingPrivilege($id){
        $data['role']        =$this->Mrole->getMenu($id);
        $data['kode_groupq'] =$id;
        $rk=$this->db->query("SELECT nama_role nama_group FROM ms_role WHERE id_inc='$id'")->row();
        $data['nama_role']          =$rk->nama_group;
         $this->template->load('blank','settingPrivilege',$data);
      /*  echo "<pre>";
        print_r($data['role']);*/
    }

    function prosessettingrole(){
        $kode_group =$_POST['kode_group'];
        $roles       =$_POST['role'];
      
        $role=$this->Mrole->do_role($kode_group,$roles);
        if($role){
            $this->session->set_flashdata('msg',  '<div class="note note-success">
                            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                            <h4>Berhasil </h4>
                            <p>Data telah disimpan.</p>
                        </div>');
            redirect('role');
        }else{
            $this->session->set_flashdata('msg',  '<div class="note note-danger">
                            <button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
                            <h4>Oppss</h4>
                            <p>Data gagal disimpan.</p>
                        </div>');
            redirect('role');
        }
    }


    function impersonate(){
        $data['rk']=$this->db->query("SELECT a.id_inc,nama,username,nama_role,nama_kontes
                                        FROM ms_pengguna a
                                        JOIN ms_role b ON a.ms_role_id=b.`id_inc`
                                        LEFT JOIN ms_kontes c ON c.`id_inc`=a.`ms_kontes_id`
                                        WHERE ms_role_id!='1'")->result();
        $this->template->load('blank','role/impersonate',$data);
    }

    

}

/* End of file Role.php */
/* Location: ./application/controllers/Role.php */
/* Please DO NOT modify this information : */
/* Generated by Harviacode Codeigniter CRUD Generator 2017-12-02 14:20:07 */
/* http://harviacode.com */